/*
 ============================================================================
 Project     : Fitness Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include "ComponentIndetification.c"

int * nodeToCompMap;
int Qtd_Tree;
int leaves;
int saveGenoma[22][200];//comporta 22 genoma contendo 200 genes cada um
int flag;
int allGenesInComps=0;
int gene=-1;//quarda o valor do elemento adjacente na pemutacao identidade



//representa a arvore
typedef struct{
    int nodeChildren[50];
    char type;//b- black w-white grey g square s
    int root;//is raiz? 1 is root 0 not is raiz
    int isleaf;
    int start;//posicao de inicio de componente no cromossomo
    int parent;
    int parei;
    
}Node;

//representa a floresta
typedef struct{
    Node * arvore;
    int size_tree;
    int qtd_leaf;
}Conteiner;

typedef struct{
	int p1[2];
    int p2[2];
    int * lista;

}listaoperacao;


char getNodeType(int orientation, int tipo) {
    
    char type;
    if (orientation)
    {
        type='b';
    }
    else
    {
        
        if (tipo == 1 || tipo == 5)
        {
            type = 'w';
        }
        else
        {
            type= 'g';
        }
    }
    return type;
}
//this flag is for free tree case computed only the distance, because not is necessary the tree
Conteiner* generateCompTree(int entrada[],int entrada2[], int siz,int genomeCappedMinus[],int genomeCappedPlus[],componente  COMPONENTS[], int flag){
  //  printf("******* Estou no construir floresta********");
    leaves=0;//set leaves 
    int i, posicao;
    int size=0;
    int compIndex = 0;
    Qtd_Tree=0;// initialy the value is 0
	int currentnod=-1;
    int square=-1;
    int descarregar=0;
    memset(nodeToCompMap,0,qtd_genes);

    
    // *************start generateStartAndEndArray *****************
    
  //  printf("TAMANHO_CAPPEPLUS %d\n ",TAMANHO_CAPPEPLUS);
     
   // int compStarts[TAMANHO_CAPPEPLUS]; // initiated private variables
    int *compStarts= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (compStarts==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 94\n");
    }
//    int compEnds[TAMANHO_CAPPEPLUS ];
    int *compEnds= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (compEnds==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 99\n");
    }
    
   
    
    for (i = 0; i < TAMANHO_CAPPEPLUS; i++)
    {
        
        compEnds[i]=-1;
        compStarts[i]=-1;
    }
   

    
    //CONT is a variable of the archive ComponentIndetification.c
    
    for (i = 0; i < CONT; i++)
    {

        compStarts[COMPONENTS[i].startIndex] = i;
        compEnds[COMPONENTS[i].endIndex] = i;
        
    }// fim for
    
    //esta validado e ok comStart e compEnd
    
    //*********************Build tree about components **************************
    int levelHasComps [CONT]; //if it has comps, go up in tree
   //int * levelHasComps=(int *) calloc (CONT, sizeof (int));
   // Node * currentNode=malloc ((TAMANHO_CAPPEPLUS) * sizeof (Node));//representa as arvores q serao quardadas
    Conteiner* compTree=malloc ((TAMANHO_CAPPEPLUS/3) * sizeof (Conteiner));//armazem de arvores
    if (compTree==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 134\n");
    }
    compTree[Qtd_Tree].arvore=malloc ((TAMANHO_CAPPEPLUS)* sizeof (Node));
    if (compTree[Qtd_Tree].arvore==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 138\n");
    }
    int *list_leaf= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (list_leaf==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 142\n");
    }
     compTree[Qtd_Tree].qtd_leaf=0;
    
    ///criando um currentnode 
    currentnod=descarregar;
    compTree[Qtd_Tree].arvore[descarregar].type='b';//representing current nodo
    leaves++;//toda vez que abrir um nodo b incremento o numero de folhas na arvore, porem mais pra frente se ele tiver filho eu decremento as folhas
    compTree[Qtd_Tree].arvore[descarregar].parent=-1;//fala quem e o pai
    compTree[Qtd_Tree].arvore[descarregar].parei=-1;
    compTree[Qtd_Tree].arvore[descarregar].start=-1;
    compTree[Qtd_Tree].arvore[descarregar].root=1;//sera uma raiz?
    compTree[Qtd_Tree].arvore[descarregar].isleaf=1;
    descarregar++;
    
    square=descarregar;
    compTree[Qtd_Tree].arvore[descarregar].type='s';//representing current nodo
    compTree[Qtd_Tree].arvore[descarregar].parent=-1;//fala quem e o pai
    compTree[Qtd_Tree].arvore[descarregar].parei=-1;
    compTree[Qtd_Tree].arvore[descarregar].start=-1;
    compTree[Qtd_Tree].arvore[descarregar].root=1;//sera uma raiz?
    compTree[Qtd_Tree].arvore[descarregar].isleaf=0;
    descarregar++;
    
    for (i=0; i<TAMANHO_CAPPEPLUS; ++i)
    {
        
     
        
        
        if (compStarts[i] > -1 && compEnds[i] == -1)
        {
            levelHasComps[size]=0; //0 is added at the end, if it remains 0 no comp was added until end of level
            size++;
        
        }//end if
        
        
        if (compStarts[i] > -1 && compEnds[i + 1] == -1)
        { //means compLength > 2

            if (compEnds[i] == -1 ||levelHasComps[size - 1] == 0)
            {
                    //criando um novo nodo square
                    square=descarregar;
                    compTree[Qtd_Tree].arvore[descarregar].type='s';//representing current nodo
                    compTree[Qtd_Tree].arvore[descarregar].parent=currentnod;//fala quem e o pai
                    compTree[Qtd_Tree].arvore[descarregar].parei=-1;
    
                    compTree[Qtd_Tree].arvore[descarregar].start=-1;
                    compTree[Qtd_Tree].arvore[descarregar].root=1;//sera uma raiz?
                    compTree[Qtd_Tree].arvore[descarregar].isleaf=0;
                
                    //carregando o indice do filho na lista
                    posicao=compTree[Qtd_Tree].arvore[currentnod].parei;
                
                if (compTree[Qtd_Tree].arvore[currentnod].type!='s') {
                    if (list_leaf[currentnod]==0) {
                        leaves--;
                        list_leaf[currentnod]=1;
                        compTree[Qtd_Tree].arvore[currentnod].isleaf=0;
                        
                    }
                }
                
                    if (posicao==-1) {
                        posicao=0;
                    }
                    else
                    {
                        posicao++;
                    }
                    compTree[Qtd_Tree].arvore[currentnod].nodeChildren[posicao]=descarregar; //update
                    compTree[Qtd_Tree].arvore[currentnod].parei=posicao; //update
                    currentnod=descarregar;//aqui e so pra manter a compatibilidade
                    descarregar++;
                

            }//end if
            
           //criar um nodo nodtype
            currentnod=descarregar;
            compTree[Qtd_Tree].arvore[descarregar].type= getNodeType(COMPONENTS[compStarts[i]].oriented, COMPONENTS[compStarts[i]].type );
            compTree[Qtd_Tree].arvore[descarregar].parent=square;//representing what have no parent
            compTree[Qtd_Tree].arvore[descarregar].root=0;//sera uma raiz
            compTree[Qtd_Tree].arvore[descarregar].parei=-1;
            compTree[Qtd_Tree].arvore[descarregar].start=i;
            compTree[Qtd_Tree].arvore[descarregar].isleaf=1;//nao tem filhos
            leaves++;
            
            if (compTree[Qtd_Tree].arvore[square].type!='s') {
                if (list_leaf[square]==0) {
                    list_leaf[square]=1;
                    compTree[Qtd_Tree].arvore[square].isleaf=0;
                    leaves--;
                }
                
            }
            
            //acrescentar filho ao nodo square
            posicao=compTree[Qtd_Tree].arvore[square].parei;
            if (posicao==-1) {
                posicao=0;
            }
            else
            {
                posicao++;
            }
            compTree[Qtd_Tree].arvore[square].nodeChildren[posicao]=descarregar; //update
            compTree[Qtd_Tree].arvore[square].parei=posicao; //update
            
            descarregar++;
            levelHasComps[size - 1]= 1; //since comp has been added to level, it is set to 1
            
           
            
            //generate arrays 4 data structure
            nodeToCompMap[compIndex] = compStarts[i];
            ++compIndex;
            

        }//end if
        
        
        else if (compEnds[i] > -1 && compStarts[i] == -1)
        {

            if (size > 0)
            {
                //passo para subir nivel
                if (levelHasComps[size - 1] == 1)
                {//only if current level has a comp, move up in tree
                    
                    currentnod=compTree[Qtd_Tree].arvore[square].parent;//busca o pai
                    if (currentnod!=0 && currentnod!=1)
                    {
                        square=compTree[Qtd_Tree].arvore[currentnod].parent;
                        
                    }
                    
                    else
                    {
                        
                                               
                            //significa que temos uma arvore
                            //copiar a arvore para o armazem
                            
                            if (descarregar>2)
                            {
                                
                                compTree[Qtd_Tree].size_tree=descarregar;
                                Qtd_Tree++;
                                compTree[Qtd_Tree].qtd_leaf=0;
                                compTree[Qtd_Tree].arvore=malloc (((TAMANHO_CAPPEPLUS - i)+2)* sizeof (Node));
                                if (compTree[Qtd_Tree].arvore==NULL) {
                                    printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 302\n");
                                }
                                memset(list_leaf,0,TAMANHO_CAPPEPLUS);
                                
                                //list_leaf= (int *) calloc ((TAMANHO_CAPPEPLUS - i)+2, sizeof (int));
                                
                            }//if do descarregar arvore
                            
                            
                            descarregar=0;

                            ///criando um currentnode
                            currentnod=descarregar;
                            compTree[Qtd_Tree].arvore[descarregar].type='b';//representing current nodo
                            leaves++;
                            compTree[Qtd_Tree].arvore[descarregar].parent=-1;//fala quem e o pai
                            compTree[Qtd_Tree].arvore[descarregar].parei=-1;
                            compTree[Qtd_Tree].arvore[descarregar].start=-1;
                            compTree[Qtd_Tree].arvore[descarregar].root=1;//sera uma raiz?
                            compTree[Qtd_Tree].arvore[descarregar].isleaf=1;
                            descarregar++;

                            square=descarregar;
                            compTree[Qtd_Tree].arvore[descarregar].type='s';//representing current nodo
                            compTree[Qtd_Tree].arvore[descarregar].parent=-1;//fala quem e o pai
                            compTree[Qtd_Tree].arvore[descarregar].parei=-1;
                            compTree[Qtd_Tree].arvore[descarregar].start=-1;
                            compTree[Qtd_Tree].arvore[descarregar].root=1;//sera uma raiz?
                            compTree[Qtd_Tree].arvore[descarregar].isleaf=0;
                            descarregar++;
                    }//end else
                }
                
                 size--;
                
            }//end if siz>0
            
        }//end else if
       // printf("\nquanto eh size_currentnod %d size_currentsq=%d\n", size_currentnod, size_currentsq);
        
    }//end for
    
    
    
    if (descarregar>2)
    {
        
        compTree[Qtd_Tree].size_tree=descarregar;
        Qtd_Tree++;
    }//if do descarregar arvore
    else
    {
        leaves--;//criamos uma folha que nao existe, assim precisamos eliminar essa folha
    
    }
    
    if (flag) {
        
        for (i=0; i<=Qtd_Tree; i++) {
            free(compTree[i].arvore);
        }
        free(compTree);
        //free(genomeCappedMinus);
       // free(genomeCappedPlus);
        free(COMPONENTS);
    }
    
    //printf("cheguei aqui?????\n");
    free(list_leaf);
  //  printf("p\n");
    free(compStarts);
   // printf("p2\n");
    free(compEnds);
   // printf("p3\n");
    //free(levelHasComps);
   // printf("p4\n");
    //printf("ufa\n");
    return compTree;
    
    
    
}//end generateCompTree

/**
     * Generates a mapping for the genes of genome A to their chromosome number.
     * It has to be updated, because the former chrom map belongs to the genome
     * sorted from 1 to N and now genome A's genes are sorted according to genome B!
     * I.e. gene 9 may now be gene 6 and if 6 and 9 are on different chromosomes
     * the old mapping still returns the chrom number of the former 6 for the current gene 6!
     * @param entrada Genoma in format string e o your size
     * @return the new chromosome mapping for the genes of A
     */
void genNewChromMap(int entrada[],int siz,int * newChromMap) {
        int i,j;
        int chromNb = 1;
        for (i = 0; i < siz; ++i)
        { 
         	newChromMap[i]=0;	
	}
        int *a= status_A(entrada,siz);
    if (a==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 401\n");
    }
         //printf("qual o tamanho mesmo %d \n",(qtd_genes+1));
        for (i = 1; i < qtd_cromossomo; ++i)
        {  
          //      printf("qual tamanho do cromossomo %d ",a[i]);
            for (j = 0; j < a[i]; ++j)
            {   
                int geneL = GENOMA_A[i][j];
               // printf("cheguei aqui*******\n");
               // printf("qual a posiccao1 %d\n",geneL);
                newChromMap[abs(geneL)] = chromNb;
		//printf("qual a posiccao2 %d\n",geneL);
            }
            ++chromNb;
        }//end for 
         
        free(a);
    
    }

void load_nodeToCompMap(){
nodeToCompMap=(int *) calloc (qtd_genes, sizeof (int));//cont eh global de componentIndetification.c
    if (nodeToCompMap==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 425\n");
    }

}

 void cromossomo(int genes[],int siz, int isCircular){

                 //meu marcador de fim sera a flag 99999
		int length = flag;//flag indica a ultima linha q foi escrita
        length++;
		int i;
		for ( i = 0; i < siz; i++) {
			
			GENOMA_A[length][i]=genes[i];
		}
		
		GENOMA_A[length][siz]=isCircular;
                flag=length;//update in flag
                if(siz+1<200)
		   GENOMA_A[length][siz+1]=99999;//indicando que aqui eh o fim do cromossomo            
               else
                printf("**************alerta acabou o espaco para o newgenoma***************\n\n\n");
}

//faz a formacao do novo genoma apos uma translocacao 
void generateGenome(int adjacencyArray[],int siz){
   
    int m=0;
    flag=-1;//setando fla pra sobrescrever desde o comeco, ja q estamos a construir um novo genoma q sofreu translocacao
   
        int currentChrom [qtd_genes];
          int current=0;
        int * visited = (int *) calloc (siz, sizeof (int));
    if (visited==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 459\n");
    }
        int j;
    for (j = 1; j < siz; ++j)
    {
        
        if (visited[j] == 0) {
            // so we start with the chromosome containing gene 1 = 0,1
            int currentAdj1 = j;
            int currentAdj2 = adjacencyArray[currentAdj1]; // j is first element, currentAdj scnd
            int geneToAdd = (currentAdj1 + 1) / 2; // (1h, 2t) --> add 1 & in while schleife 2 before 1
            if (currentAdj1 % 2 == 0) { // if tail gene is negative
                geneToAdd *= -1;
            }
            //currentChrom.add(geneToAdd);
            //printf("adicionai geneToAdd %d\n",geneToAdd);
            currentChrom[current]=geneToAdd;
            current++;
            visited[currentAdj1] = 1;
            
            // first direction 1t, extend to left
            while (((currentAdj2 % 2 == 1 && !visited[currentAdj2 + 1]) || (currentAdj2 % 2 == 0 && !visited[currentAdj2 - 1]))
                   && currentAdj1 != currentAdj2) { // as long as no circle or telomere
                geneToAdd = (currentAdj2 + 1) / 2;
                if (currentAdj2 % 2 == 1) { // if head gene is negative
                    geneToAdd *= -1;
                }
               // printf("adicionai geneToAdd na pos 0 %d\n",geneToAdd);
                //-------- processo de deslocar uma posicao a frente
                
                m=current-1;
                for (; m>=0; m--) {//qtd_genes eh global de validaentrada.c
                      currentChrom[m+1]=currentChrom[m];
                }
                
                currentChrom[0]=geneToAdd;
                current++;
                visited[currentAdj2] = 1;
                
                // get values of next adjacency
                if (currentAdj2 % 2 == 0) { // currently tail was reviewed, f.e. (1t,3h) -> j=3t
                    currentAdj1 = --currentAdj2;
                } else {
                    currentAdj1 = ++currentAdj2;
                }
                currentAdj2 = adjacencyArray[currentAdj1]; // f.e. currentAdj = list[3t] = 5h
                visited[currentAdj1] = 1;
            }
            
            if (currentAdj1 != currentAdj2
                && ((currentAdj2 % 2 == 1 && visited[currentAdj2 + 1]) || (currentAdj2 % 2 == 0 && visited[currentAdj2 - 1]))) {
                //if circle chrom is complete
                
                cromossomo(currentChrom,current,1);
                current=0;
                visited[currentAdj1] = 1;
                visited[currentAdj2] = 1;
            }
            else
            {
                // second direction if not circular, way to scnd telomere
                // get values of next adjacency
                if (currentAdj1 == currentAdj2)
                {
                    visited[currentAdj1] = 1;
                    if (j % 2 == 0) { // currently tail was reviewed, f.e. (3t) -> currentAdj1=3h
                        currentAdj1 = j - 1;
                    }
                    else {
                        currentAdj1 = j + 1;
                    }
                }
                else
                {
                    // System.out.println("case exists IntermedGenomeGenerator");
                    if (currentAdj2 % 2 == 0) { // currently tail was reviewed, f.e. (3t) -> currentAdj1=3h
                        currentAdj1 = --currentAdj2;
                    } else {
                        currentAdj1 = ++currentAdj2;
                        // System.out.println("Case exists: intermed genomes generator 2");
                    } // TODO: does this case exist?
                }
                
                currentAdj2 = adjacencyArray[currentAdj1]; // f.e. currentAdj = list[3t] = 5h
                while (currentAdj1 != currentAdj2) { // !visited[currentAdj] cannot occur here
                    geneToAdd = (currentAdj2 + 1) / 2;
                    if (currentAdj2 % 2 == 0) { // if tail gene is negative
                        geneToAdd *= -1;
                    }
                   //printf("adicionai geneToAdd %d\n",geneToAdd);
                    currentChrom[current]=geneToAdd;
                    current++;
                    visited[currentAdj1] = 1;
                    visited[currentAdj2] = 1;
                    
                    // get values of next adjacency
                    if (currentAdj2 % 2 == 0) { // currently tail was reviewed, f.e. (1t,3t) -> j=3h
                        currentAdj1 = --currentAdj2;
                    } else {
                        currentAdj1 = ++currentAdj2;
                    }
                    currentAdj2 = adjacencyArray[currentAdj1]; // f.e. currentAdj = list[3h] = 5t
                }
		
                 cromossomo(currentChrom,current,0);
                current=0;
                visited[currentAdj1] = 1;
            }
            m=0;
            for(;m<qtd_genes;m++)
                currentChrom[m]=0;
            current=0;
            //currentChrom = new ArrayList<Integer>();
        }
    } //end for
    
    
    free(visited);
	
	}//end function
	

int * generateGeneInCompArray( componente components[], int plusCappedGnom[], int numberOfGenes) {
   int * geneInCompArray =(int *) calloc (numberOfGenes + 1, sizeof (int));
    if (geneInCompArray==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 584\n");
    }
    
    int counter = 0;
   int start,end,i,j;
   int compBorders[2];
    for ( i = 0; i < CONT ; ++i) {
       
        if (components[i].startIndex < components[i].endIndex)
        {
                compBorders[0]=components[i].startIndex;
                compBorders[1]=components[i].endIndex;
        }
        else
        {
            compBorders[0]=components[i].endIndex;
            compBorders[1]=components[i].startIndex;
        }
        //start = compBorders.getFirst();
        start=compBorders[0];
        end = compBorders[1];
        if (end - start >= 2) {
            for ( j = start; j <= end; ++j) {
                if (geneInCompArray[abs(plusCappedGnom[j])] == 0) {
                    ++counter;
                }
                geneInCompArray[abs(plusCappedGnom[j])] = 1;
            }
        }
    }
    if (counter == numberOfGenes)
    {
        allGenesInComps = 1;
    }
    else
    {
        allGenesInComps = 0;
    }
    return geneInCompArray;
}


int * generateGeneAtCompBorderArray(componente components[], int plusCappedGnom[], int numberOfGenes) {
   int * geneAtCompBorderArray = (int *) calloc (numberOfGenes + 1, sizeof (int));
    if (geneAtCompBorderArray==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 629\n");
    }
    int compBorders[2];
   int start,i;
   int end;
   for ( i = 0; i < CONT ; ++i) {
       if (components[i].startIndex < components[i].endIndex)
       {
           compBorders[0]=components[i].startIndex;
           compBorders[1]=components[i].endIndex;
       }
       else
       {
           compBorders[0]=components[i].endIndex;
           compBorders[1]=components[i].startIndex;
       }
       //start = compBorders.getFirst();
       start=compBorders[0];
       end = compBorders[1];
        if (end - start >= 2) {
            geneAtCompBorderArray[abs(plusCappedGnom[start])] = 1;
            geneAtCompBorderArray[abs(plusCappedGnom[end])] = -1;
        }
        
    }
    return geneAtCompBorderArray;
}


int * generatePosDepthArray(int plusCappedGnom[], componente components[],int numberOfGenes) {
    
    int* posDepthArray =  (int *) calloc (numberOfGenes + 1, sizeof (int));
    if (posDepthArray==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 662\n");
    }
    int iComp;
    int start;
    int stop,i;    
    for (i = 0; i < CONT; ++i)
    {
       // printf("(%d, %d)\n",components[i].startIndex,components[i].endIndex);
        
        iComp = nodeToCompMap[i];
        if (iComp > 0)
        {
            start = components[iComp].startIndex;
            stop = components[iComp].endIndex;
            int val,j;
            for (j = start; j <= stop; ++j)
            {
                val = abs(plusCappedGnom[j]);
                if (val > 0 && val <= numberOfGenes) {
                    ++posDepthArray[val];
                }
            }//end for
        }//end if
    }//end for
    
    return posDepthArray;
}


int numberLeaves(Conteiner compTree[], int siz){
    int i,j;
    int cont=0;
    for (i=0; i<Qtd_Tree; i++) {
        //printf("t arvores:%d\n",compTree[i].size_tree);
        for (j=0; j<compTree[i].size_tree; j++)
        {
            
            if (compTree[i].arvore[j].isleaf==1)
            {
                cont++;
            }//end if
            
        }//end for
    }//end for

    return cont;
}
/**
 * Calculates the extremity number used in the adjacency array from the gene number.
 * @param geneExt gene index already *2
 * @param fstExtremity(variable representation value boolean) if it is the left extremity of an adjacency
 * @return the correct extremity
 */
 int  getExtremity1(int geneExt, int fstExtremity) {
     
    if (geneExt < 0 && fstExtremity) {
        return (geneExt * -1) - 1;
    }
    else if (geneExt < 0 && !fstExtremity) {
        return -geneExt;
    }
    else if (geneExt > 0 && !fstExtremity) {
        return geneExt - 1;
    }
    return geneExt;
}//end function

 void generateInvolvedExtremities( int start, int plusCappedGnom[], int chromMap[],int geneInCompArray[],int geneAtCompBorderArray[], int posDepthArray[], int entrada[], int siz,int involvedExtremities[])
{
    int * status= status_A( entrada,siz);
    if (status==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 733\n");
    }
    involvedExtremities[0] = getExtremity1(plusCappedGnom[start] * 2, 1);
    involvedExtremities[1] = getExtremity1(plusCappedGnom[start + 1] * 2, 0);
  //  printf("involvedExtremities[0] %d involvedExtremities[1] %d \n",start,involvedExtremities[1]);
    int chromNb = chromMap[abs(plusCappedGnom[start])]; //chrom number can't change during while loop
    int doesntFit = 1;
    int cutChromNb = 0;
    int i ;
    int * chrom =copiar_cromossomo(cutChromNb, status[cutChromNb], 1);//referente ao arquivo adjacentygraph.c
    i=0;
    
    if (allGenesInComps)//variavel global
    {
        if ((cutChromNb < qtd_cromossomo - 1) && (chromNb == cutChromNb))
        {
            free(chrom);
            //chrom = genomeA.getChromosome(++cutChromNb).getGenes(); //must always work as there cant be only 1 chrom
            ++cutChromNb;
            chrom =copiar_cromossomo(cutChromNb, status[cutChromNb],1);
        }//end if
        involvedExtremities[2] = getExtremity1(chrom[0] * 2, 1);
        involvedExtremities[3] = getExtremity1(chrom[1] * 2, 0);
    }//end if
    
    else
    {
        while (doesntFit)
        {
            if (cutChromNb < qtd_cromossomo - 1 && (chromNb == cutChromNb || i >= status[cutChromNb] - 2))
            {
                ++cutChromNb; //must always work as there cant be only 1 chrom
                if (cutChromNb == chromNb)
                {
                    ++cutChromNb;
                }
                free(chrom);
                chrom= copiar_cromossomo(cutChromNb, status[cutChromNb],1);
                i = 0;
            }//end if
            int geneL = chrom[i];
            int geneAbs;
            while ((geneInCompArray[geneAbs = abs(geneL)] && i < status[cutChromNb] - 2) &&
                   (( (geneAtCompBorderArray[geneAbs] == 1 && i == 0) ||
                     (geneAtCompBorderArray[geneAbs] == -1 && i == status[cutChromNb] - 1) || //a comp border & between
                     ( ((geneAtCompBorderArray[geneAbs] == 1 && i == 0) ||
                        (geneAtCompBorderArray[geneAbs] == -1 && i == status[cutChromNb] - 1))
                      && posDepthArray[geneAbs] > 1) ) || // 2 comps at top level in tree there can be a cut.
                    geneAtCompBorderArray[geneAbs] == 0)) { //means comp is not directly below root of tree = at least in scnd layer
                       
                       geneL = chrom[++i];
                   }
            if (i == status[cutChromNb] - 1) {
                doesntFit = 1;
            } else {
                involvedExtremities[2] = getExtremity1(geneL * 2, 1);
                involvedExtremities[3] = getExtremity1(chrom[i + 1] * 2, 0);
                doesntFit = 0;
            }
            
        }//while
    }//else
    
    
    if ( involvedExtremities[2]==0 || involvedExtremities[3]==0)
    {
        
        cutChromNb = 0;
        chromNb = chromMap[abs(plusCappedGnom[start])];
        chrom =copiar_cromossomo(cutChromNb, status[cutChromNb], 1);//referente ao arquivo adjacentygraph.c
        if (cutChromNb < qtd_cromossomo - 1 && chromNb == cutChromNb)
        {
            free(chrom);
            //chrom = genomeA.getChromosome(++cutChromNb).getGenes(); //must always work as there cant be only 1 chrom
            ++cutChromNb;
            chrom =copiar_cromossomo(cutChromNb, status[cutChromNb],1);
        }//end if
        involvedExtremities[2] = getExtremity1(chrom[0] * 2, 1);
        involvedExtremities[3] = getExtremity1(chrom[1] * 2, 0);
    }
    
    free(status);
   
    
}//end generateInvolvedExtremities


/**
 * Tests if the components are on different chromosomes or not.
 * @param compMap the mapping of components to chromosomes
 * @param component
 * @return <code>true</code> if they are on different chroms, <code>false</code> otherwise
 */
int  testCompsOnDiffChroms( int compMap[],int size_compMap,componente components[], int size_comp) {
    int fstChromNb = -1;
    int scndChromNb = -1;
    int i;
    int largeComp = 0;
    
   i = 1;
    while (i < size_compMap && scndChromNb == -1) {
 
        largeComp = abs(components[i].endIndex - components[i].startIndex);
        if (largeComp >= 2)
        {
            if (fstChromNb == -1)
            {
                fstChromNb = compMap[i];
                
            }
            else if (fstChromNb != compMap[i])
            {
                scndChromNb = compMap[i];
            }
        }
        ++i;
    }
    if (fstChromNb != scndChromNb && fstChromNb != -1 && scndChromNb != -1 && size_compMap > 1) {
        return 1;
    }
    return 0;
    
}//end components



/**
 * Generates an integer array containing a mapping for each component
 * index in the component array to the chromosome number the component is
 * located on.
 * @param chromMap the chromosome map for the genes in genome A
 * @param components the component array
 * @param plusCappedGnom the plus capped genome A
 * @return the component to chromosome mapping array
 */
void generateCompMap(int chromMap[], componente components[],int tamanho, int plusCappedGnom[], int * compMap) {
   // int * compMap = (int *) calloc (tamanho, sizeof (int));
    int i;
    
    for (i=0; i<tamanho; i++) {
        compMap[i]=0;
    }
    for (i=0; i < tamanho; ++i) {
        int geneL = plusCappedGnom[components[i].startIndex];
        compMap[i] = chromMap[abs(geneL)];
    }
    

}


int calcTransDist(int numbercicles, int qtdgenes, int qtdcromossomo, int leaves,int qtdtree ){
    int t;
    
    if (leaves%2==0 && qtdtree==1)
        t= leaves+2;
    
    else if(leaves%2==1)
        t=leaves+1;
    else
        t=leaves;
    //-----------------------------------calculo da distancia esta feito aqui-------------------------------------
return qtdgenes - qtdcromossomo - numbercicles + t;
    
}

/**
 * Assigns the four involved extremities for an operation in the adjacency graph.
 * @param involvExtremities the four involved extremities
 * @param adjArray1 the adjacency graph array
 * @param standard true for standard assignment: (0, 3) & (1,2) together, false for (0,2) (1,3)
 * @return the modified adjacency graph array
 */
int * assignInvolvedExtr( int involvExtremities[], int adjArray1[], int  standard) {
    if (standard)
    {
        adjArray1[involvExtremities[0]] = involvExtremities[3];
        adjArray1[involvExtremities[3]] = involvExtremities[0];
        adjArray1[involvExtremities[1]] = involvExtremities[2];
        adjArray1[involvExtremities[2]] = involvExtremities[1];
    }
    
    else
    {
        adjArray1[involvExtremities[0]] = involvExtremities[2];
        adjArray1[involvExtremities[2]] = involvExtremities[0];
        adjArray1[involvExtremities[1]] = involvExtremities[3];
        adjArray1[involvExtremities[3]] = involvExtremities[1];
    }
    
    return adjArray1;
}

//Returns the mapping of each leaf to its index of the associated component
int * getLeafToIndexMap(Conteiner compTree[], int siz, int folhas){
    
    int * leafToIndexMap = (int *) calloc (folhas, sizeof (int));
    if (leafToIndexMap==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 934\n");
    }
    int i,j;
    int cont=-1;
    
    for (i=0; i<Qtd_Tree; i++) {
        
               
     
        for (j=0; j<compTree[i].size_tree; j++)
        {

                                    
            if (compTree[i].arvore[j].isleaf==1)
            {
                
                cont++;
                leafToIndexMap[cont]=i;

                
            }//end if
            
        }//end for
         
    }//end for
    return leafToIndexMap;

}

//retorna qual crmossomo o gene pertence
int verifica_crhom(int posgene, int entrada[],int siz){
    int i;
    int cont=0;
    for (i=0; i<siz; i++)
    {
        if (entrada[i]==0) {
            cont++;
        }
        if(i==posgene)
            break;
    }

    return cont;
}

//retorna uma folha da big arvore
int leaf_bigTree(Conteiner compTree[],int siz,int nodeIBigTree, int leafToIndexMap[],int siz2)
{
    int i;
    int retorno;
    for (i=0; i<siz2; i++)
    {
        if (leafToIndexMap[i]==nodeIBigTree) {
            if (leafToIndexMap[i]==0) {
                printf("******************lancar erro pois esta com problema na struct na leafToIndexMap***************************");
            }
            else
                break;
        }
    }//end for
    
    retorno=leafToIndexMap[i];
    if (compTree[nodeIBigTree].size_tree>2) {
        i=i+2;
        if (leafToIndexMap[i+1]==nodeIBigTree)
        {
            retorno=leafToIndexMap[i];
        
        
        }
    }
    return retorno;

}



/**
 * Checks if there exists a component longer than 2 elements.
 * @param components component array
 * @return true if there is a component longer than 2 elements (at least 3 elements)
 */
int checkCompLength(componente components[],int siz) {
    int i;
    for (i = 0; i < siz; ++i) {
        if (abs(components[i].endIndex - components[i].startIndex) >= 2) {
            return 1;
        }
    }
    return 0;
}


void clona_genoma(){

    
    int i=0;
    int j=0;
    while (j<=flag) {
        
        
        while (GENOMA_A[j][i]!=99999) {
            saveGenoma[j][i]=GENOMA_A[j][i];
            i++;
        }//end while interno
       
         saveGenoma[j][i]=GENOMA_A[j][i];
        j++;
        i=0;
        
    }//end while externo


}
//recovery genoma by suport genoma
void rec_genoma(){

    int i=0;
    int j=0;
    while (j<=flag) {
        
        
        
        while (saveGenoma[j][i]!=99999)
        {
            GENOMA_A[j][i]=saveGenoma[j][i];
            i++;
        }//end while interno
        GENOMA_A[j][i]=saveGenoma[j][i];
        j++;
        i=0;
        
    }//end while externo


}

int * SavePlusCapped( int genomeCappedPlus[], int SavePlusCapped[]){
    int i;
    for (i=0; i<TAMANHO_CAPPEPLUS; i++) {
        SavePlusCapped[i]=genomeCappedPlus[i];
    }
    return SavePlusCapped;
}

int * SaveMinCapped( int genomeCappedMinus[], int saveMinCapped[]){
    int i;
    for (i=0; i<TAMANHO_CAPPEPLUS; i++) {
        saveMinCapped[i]=genomeCappedMinus[i];
    }
    return saveMinCapped;
}
int * reconstruirentrada(int newentrada[], int siz){
    
   int i=0;
   int j=0;
   int cont=0;
     while (j<=flag) {
        
        
        while (GENOMA_A[j][i]!=99999) {
            if (GENOMA_A[j][i+1]!=99999)
            {
                
                newentrada[cont]=GENOMA_A[j][i];
                cont++;
            }
            else
            {
                if(cont<siz-1)
                {
                    newentrada[cont]=GENOMA_A[j][i]=0;
                    cont++;
                }
            }
            i++;
        }//end while interno
        j++;
        i=0;
        
    }//end while externo
    return newentrada;
}

//faz o mapeamento retornando os indices pra cada componente folha na arvore
int * TreeIndexMap(Conteiner compTree[],int siz, int folhas){
    int *treeIndexMap=(int *) calloc (folhas, sizeof (int));
    if (treeIndexMap==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1122\n");
    }
    int i,j;
    int cont=0;
    for (i=0; i<Qtd_Tree; i++) {
        for (j=0; j<compTree[i].size_tree; j++)
        {
            if (compTree[i].arvore[j].isleaf==1)
            {
                 treeIndexMap[cont]=i;
            }//end if
            
        }//end for
        cont++;
    }//end for
   
    return treeIndexMap;
}

/**
 * Utility method returning the index of the first leaf of a tree in the component array.
 * @param treeIndex index of the tree
 * @param leafToIndexMap mapping of leaves to indices in the component array
 * @return the index of the first leaf in the component array
 */
 int getFstLeafOfTree(int treeIndex, int leafToIndexMap[],int siz) {

    int i = 0;
    int fstLeaf = 0;
     
     
     while (fstLeaf < treeIndex) {
         fstLeaf=leafToIndexMap[++i];
     }
     
     
     return fstLeaf;
}

/**
 * Checks for two extremities if a translocation at this position was already carried out
 * and identified as improper.
 * @param ex first cut extremity
 * @param startEx second cut extremity
 * @param adjG1 adjacency graph
 * @param improperAdjs the array of improper adjacencies
 * @return <code>true</code> if the translocation would be improper
 */
int checkImproper(int ex, int startEx, int adjG1[],int improperAdjs[],int siz) {//improperAdjs representa um arranjo de pares (i, i+1)
    int i;
    for ( i = 0; i < siz; i=i+2) {
        int fst = improperAdjs[i];
        int scnd = improperAdjs[i+1];
        int t=i;
        t=t+2;
        
        int thrd = improperAdjs[t];
        int fourth = improperAdjs[t+1];
        if (ex == fst || ex == scnd || ex == thrd || ex == fourth)
        {
            if (startEx == fst || startEx == scnd || startEx == thrd || startEx == fourth) {
                int ex3 = adjG1[ex];
                
                if (ex3 == fst || ex3 == scnd || ex3 == thrd || ex3 == fourth)
                {
                    int ex4 = adjG1[ex];
                    if (ex4 == fst || ex4 == scnd || ex4 == thrd || ex4 == fourth)
                    {
                        return 1;
                    }
                }
            }
        }//end if
        i=i+2;
    }//end for
    return 0;
}


/**
 * Checks if adjacent genes are on same chromosome or not. It is returned negative, if the tail of the
 * previous gene is wanted and positive if the head of the concurrent gene is wanted.
 * @param plusCappedGnom genome
 * @param newChromMap mapping of gene to chrom nb
 * @param start index of gene
 * @param nbGenes the number of genes in the genome
 * @return true if both are on same chrom
 */
int  ChromCheck(int plusCappedGnom[], int newChromMap[], int start, int nbGenes) {
    int curGene = abs(plusCappedGnom[start]);
    int chromCheck ;
    if (curGene > nbGenes || curGene == 0) {
        chromCheck=1;
    }
    else
        chromCheck=0;
    
    if (!chromCheck)
    {
      //  printf("Entrei no if mais externo\n");
        if (getExtremity1(plusCappedGnom[start] * 2, 1) % 2 == 1) {
            
            chromCheck = (newChromMap[curGene] == newChromMap[curGene - 1])
            || (((plusCappedGnom[start] < 0) && (plusCappedGnom[start + 1] > nbGenes)) //it is true, if this is a chromosome border
                || ((plusCappedGnom[start] > 0) && (plusCappedGnom[start - 1] == 0))); //because we want to skip it!
            
	    gene = -1 * (curGene - 1);
        //    printf("Entrei no primeiro if interno %d\n",chromCheck);
        }
        
        else
        {
            chromCheck =  (newChromMap[curGene] == newChromMap[curGene + 1])
            || (((plusCappedGnom[start] < 0) && (plusCappedGnom[start - 1] == 0)) //it is true, if this is a chromosome border
                || ((plusCappedGnom[start] > 0) && (plusCappedGnom[start + 1] > nbGenes))); //because we want to skip it!
            gene = curGene + 1;
        }
        if (chromCheck)
        {
            //printf("entrei nesse if true de cara \n");
            curGene = abs(plusCappedGnom[start + 1]);
            chromCheck = curGene > nbGenes || curGene == 0;
            if (!chromCheck)
            {
                if (getExtremity1(plusCappedGnom[start + 1] * 2, 0) % 2 == 1)
                {
                    chromCheck = newChromMap[curGene] == newChromMap[curGene - 1]; //because we want to skip it!
                    gene = curGene - 1;
                }
                else
                {
                    chromCheck = newChromMap[curGene] == newChromMap[curGene + 1]; //because we want to skip it!
                    gene = -1 * (curGene + 1);
                }
            }
        }
    }//end if
    return chromCheck;
}



/**
 * Finds gene in genome.
 * @param plusCappedGnom
 * @return index of geneIndex
 */
int *genScndCut(int plusCappedGnom[], int adjacency[]) {
    int extremity = -1;
    int i;
    for (i = 0; i < TAMANHO_CAPPEPLUS; ++i) {
        if (abs(plusCappedGnom[i]) == abs(gene))
        {//gene aqui eh global desse proprio arquivo
            if (gene < 0)
            { //get tail of this gene
                extremity = -1 * gene * 2;
            }
            else
            { //get head
                extremity = gene * 2 - 1;
            }
            if (((plusCappedGnom[i] < 0) && (gene < 0)) || ((plusCappedGnom[i] > 0) && (gene > 0)) ) { //check orientation of gene in genome
              
               if( i>0 && plusCappedGnom[i-1]==0)   
	       {
		    adjacency[0] = extremity+1;
                    adjacency[1] = getExtremity1(plusCappedGnom[i + 1] * 2, 0); // cut right of gene;
                 
               }  
               else
                {
                 adjacency[0] = getExtremity1(plusCappedGnom[i - 1] * 2, 1); // cut left of gene
                 adjacency[1] = extremity;
                 
                }
            
            }
            else
            {
		adjacency[0] = extremity;
                adjacency[1] = getExtremity1(plusCappedGnom[i + 1] * 2, 0); // cut right of gene;
            }
            break;
        }
    }
    return adjacency;
}

int * clonar_adjG1(int adjArray1[], int adjG1[], int siz){
  
   int i;
   for(i=0;i<siz;i++)
	adjArray1[i]=adjG1[i];		

return adjArray1;
}


int * recoveryPlusCapped(int savePlusCapped[], int genomeCappedPlus[], int siz){
	int i;
	for(i=0;i<siz;i++)
	{
		genomeCappedPlus[i]=savePlusCapped[i];


	}
return genomeCappedPlus;
}



int * recoveryMinCapped(int saveMinCapped[],int genomeCappedMinus[], int siz){
	int i;
	for(i=0;i<siz;i++)
	{
		genomeCappedMinus[i]=saveMinCapped[i];


	}
return genomeCappedMinus;
}

int distance(int entrada[],int entrada2[], int siz, int senti){
   int t;
    
    
    // printf("***********Distance***********************\n");
    identifyComponents( entrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
    
   //  printf("a\n");
    cappingM(entrada, siz);
   // printf("b\n");
    cappingP(entrada,siz);
    //printf("c\n");
    int nbegnes=qtd_genes;
    componente * COMPONENTS=compIdentificationPhase12(nbegnes,entrada, entrada2, siz);
   // printf("d Cont%d\n",CONT);

    generateCompTree(entrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,1);
   // printf("sai aqui??????\n");
    
     //printf("e\n");
    //calcular operacao relacionado ao numero de arvores e folhas
    
    if (leaves%2==0 && Qtd_Tree==1)
        t= leaves+2;
    
    else if(leaves%2==1)
        t=leaves+1;
    else
        t=leaves;
    
    free(greatestPrecursors);
    free(greatestSuccessors);
    free(smallestSuccessors);
    return nbegnes - qtd_cromossomo - numberOfCycles + t;

}//end function 


void grava( listaoperacao operationList[], int n, int siz, int dist){
    char *nombre_archivo = "ArqGrav.txt"; //archivo "i"
    FILE *filePointer;
    int i,j;
    /*Guardar Permutacao no arquivo*/
    if ((filePointer = fopen(nombre_archivo,"w")) == NULL){
        printf("Output file could not be opened\n");
    }
    else
    {
	fprintf(filePointer,"********************************\n");
        fprintf(filePointer,"A Distancia de Translocacao e: %d\n",dist);
	fprintf(filePointer,"********************************\n");
        fprintf(filePointer,"Entrada Inicial\n");
        for(i=0; i<=n; i++)
       {


	  for(j=0;j<siz;j++)
         {  
	   		
           if(j==0)
	   {
	      fprintf(filePointer,"(%d,",operationList[i].lista[j]); 
           }	
           else if(j+1==siz)
          {
	     fprintf(filePointer,"%d)",operationList[i].lista[j]);
          } 
          else if(operationList[i].lista[j]==0)
	  {
        	fprintf(filePointer,") (");
          }
	  else if(operationList[i].lista[j+1]==0)
          {
		fprintf(filePointer,"%d",operationList[i].lista[j]);
          }	
          else
          {
		fprintf(filePointer,"%d,",operationList[i].lista[j]);
          }
       }	
      fprintf(filePointer,"\n");
      fprintf(filePointer,"\n");	           
     }
	//fclose(filePointer);
   }
   
    
    
}//fim da funcao


int unica_translocacao(int entrada[], int siz)
{
    int i,j;
    int mesmo_cromo=0;
    int cromi=0;
    int cromj=0;
    int captura=-1;
    
    
    
    for (i=1; i<siz-1; i++)
    {
        //evitar os extremos
        if (i!=siz-1 && entrada[i+1]!=0 && entrada[i-1]!=0)
        {
            
            
            if (entrada[i]==0) {
                cromi++;
            }
            
            
            for (j=1; j< siz-1; j++)
            {
                
                if (entrada[j]==0)
                {
                    cromj++;
                }
                
                if ((entrada[i]!=entrada[j]) && j!=siz-1 && entrada[j+1]!=0 && entrada[j-1]!=0)
                {
                    
                                       
                    
                    if (abs(entrada[i])== abs(entrada[j]+1) || abs(entrada[i])== abs(entrada[j]-1))
                    {
                        if (cromj!=cromi)
                        {

                            if (captura==-1) {
                                captura=i;
                            }
                            
                            mesmo_cromo++;
                        }
                        
                    }//end if
                }//end if
                
            }//end for
          
            cromj=0;
            
            
        }//end if
    }//end for

   
    if ((mesmo_cromo/2)>1) {
        return 0;
    }
    
    return captura;

}



///funcao de escape para recuperar segundo gene pra aplicar uma translocacao
int recuperasegundogene(int rec,int newentrada[], int siz)
{
    //buscar o gene
    int cromi=0;
    int cromj=0;
    int t;
    for (t=0; t<siz; t++)
    {
        if (newentrada[t]==0)
            cromi++;
        if (t==rec)
            break;
        
    }
    
    for (t=0; t<siz; t++)
    {
        if (newentrada[t]==0) {
            
                cromj++;
        }
            if (abs(newentrada[rec]+1) == abs(newentrada[t])  || abs(newentrada[rec]-1) == abs(newentrada[t]) )
            {
                
                if (cromj!=cromi) {
                    break;
                }
                
            }
            
        }
    

    return t;

}

int d_tranlocation(int entrada[],int entrada2[], int siz){
    int cont_dist=0;
    int *improperAdjs=(int *) calloc ((2* siz), sizeof (int));
    if (improperAdjs==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1526\n");
    int cont_improper=0;
    int improper=0;
    int * newentrada=(int *) calloc (siz, sizeof (int));//quarda a nova entrada apos uma tranlocacao
    if (newentrada==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1531\n");
    int * scndCut= (int *) calloc (2, sizeof (int));
    if (scndCut==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1534\n");
    flag=-1;//marca a ultima posicao usada no newgenoma, aqui estamos apenas iniciando
    int allGenesInComps=0;
    int needAnotherPreStep=0;
    int t,i,j;
    int *adjNew=(int *) calloc ((2 * qtd_genes + 1), sizeof (int));
    if (adjNew==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1541\n");
    int * adjArray1=(int *) calloc ((2 * qtd_genes + 1), sizeof (int));
    if (adjArray1==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1544\n");
    int scndCase=0;//faz uso como variavel booleana
    int newTransDistance;
    int lastImpr = 2;
    identifyComponents2( entrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
    cappingM(entrada, siz);
    cappingP(entrada,siz);
    int nbegnes=qtd_genes;
    componente * COMPONENTS=compIdentificationPhase12(nbegnes,entrada, entrada2, siz);
    if (COMPONENTS==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1553\n");
    nodeToCompMap=(int *) calloc (qtd_genes, sizeof (int));//cont eh global de componentIndetification.c
    if (nodeToCompMap==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1556\n");
    Conteiner* compTree= generateCompTree(entrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
    if (compTree==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1559\n");
    int * geneInCompArray=generateGeneInCompArray( COMPONENTS, genomeCappedPlus, nbegnes);
    if (geneInCompArray==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1562\n");
    int *geneAtCompBorderArray= generateGeneAtCompBorderArray(COMPONENTS, genomeCappedPlus, nbegnes);
    if (geneAtCompBorderArray==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1565\n");
    int *posDepthArray=generatePosDepthArray(genomeCappedPlus, COMPONENTS,nbegnes);
    if (posDepthArray==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1568\n");
    int * newChromMap=(int *) calloc ((qtd_genes + 2), sizeof (int));
    if (newChromMap==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1572\n");
    genNewChromMap( entrada,siz, newChromMap);
    int * compMap = (int *) calloc (CONT, sizeof (int));
    if (compMap==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1575\n");
    generateCompMap(newChromMap, COMPONENTS,CONT,genomeCappedPlus, compMap);
    int *savePlusCapped= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (savePlusCapped==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1579\n");
    int *saveMinCapped=(int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (saveMinCapped==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1583\n");
    //status indica se eh para o genoma A ou B
    int *adjG1= parseAdjacencies(1,  entrada,siz);
    if (adjG1==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1587\n");
    int *adjG2=parseAdjacencies(2,  entrada2,siz);//load genoma B
    if (adjG2==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1589\n");
    int  involvExtremities[4];
    int *visited=(int *) calloc ((2 * qtd_genes + 1), sizeof (int));
    if (visited==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1594\n");
    //calcular operacao relacionado ao numero de arvores e folhas
    
    if (leaves%2==0 && Qtd_Tree==1)
        t= leaves+2;
    
    else if(leaves%2==1)
        t=leaves+1;
    else
        t=leaves;
    //-----------------------------------calculo da distancia esta feito aqui-------------------------------------
    int distancia = qtd_genes - qtd_cromossomo - numberOfCycles + t;
    newTransDistance=distancia;//so pra conferir se diminui minha distancia
    listaoperacao * operationList = malloc ((distancia+2) * sizeof (listaoperacao));//so pra nao deixar estourar em caso de excesso
    int contop=0;
    int dist_escrava=distancia;
    ////////////////////////////////////////
    // calcular leafToIndexMap-------------
    int * leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
    if (leafToIndexMap==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1614\n");
    int *treeIndexMap=TreeIndexMap(compTree,Qtd_Tree,leaves);//mapeia folhas na arvore relacionando a componentes
    if (treeIndexMap==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1616\n");
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    //----------reduce the number of leaves/components to an even number or destroy last tree--------------
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    generateGenome(adjG1,2*qtd_genes+1);
    newentrada=reconstruirentrada(entrada,siz);
    
    if ((allGenesInComps && leaves%2==0 && Qtd_Tree==1) || (leaves%2==0 && Qtd_Tree==1) ||leaves%2==1)
        needAnotherPreStep=1;
    operationList[contop].lista= (int *) calloc (siz, sizeof (int));
    if (operationList[contop].lista==NULL)
        printf("ATENCAO PERCA DE MEMORIA, Preprocessamento.c, LINE 1628\n");
    for (i=0; i<siz; i++)
        operationList[contop].lista[i]=entrada[i];
    while (needAnotherPreStep)
    {
        
        if (leaves % 2 == 0 && Qtd_Tree == 1)
        {
            //also means whole genome cannot be covered by components
            //destroy any leaf of the single tree such that L' = L-1
            
            int iFirstLeaf = -1;
            
            //buscar a primeira folha da arvore
            for (i=0; i<compTree[0].size_tree; i++)
            {
                
                
                if (compTree[0].arvore[i].isleaf)
                {
                    iFirstLeaf=i;
                    break;
                }
            }
            if (iFirstLeaf==-1 || compTree[0].arvore[iFirstLeaf].isleaf!=1)
            {
                printf("LANCAR ERRO EM QTD_TREE==1 e leaves par HA UM ERRO \n");
                break;
            }
            int start = compTree[0].arvore[iFirstLeaf].start;
            generateInvolvedExtremities( start, genomeCappedPlus,newChromMap,geneInCompArray,geneAtCompBorderArray,posDepthArray, newentrada, siz, involvExtremities);
            
            //save operations. Note that algos always have to store op in this order! result will be corrupted otherwise
            
            contop++;
            adjG1= assignInvolvedExtr( involvExtremities,adjG1, 1);
            operationList[contop].p1[0]=involvExtremities[0];
            operationList[contop].p1[1]=involvExtremities[3];
            operationList[contop].p2[0]=involvExtremities[1];
            operationList[contop].p2[1]=involvExtremities[2];
            //clonar a lista
	        
            operationList[contop].lista= (int *) calloc (siz, sizeof (int));
            
            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            //----------------------- update all data structures after operation -----------------
            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            
            
            generateGenome(adjG1,2*qtd_genes+1);
            newentrada=reconstruirentrada(newentrada,siz);
            for (i=0; i<siz; i++)
                operationList[contop].lista[i]=newentrada[i];
            genNewChromMap( newentrada,siz,newChromMap);
            cappingP(newentrada,siz);//atualizando
            cappingM(newentrada, siz);
            free(COMPONENTS);
            free(genomeCappedPlus);
            free(genomeCappedPlus);
            identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
            COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
            free(compTree);
            compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
            generateCompMap(newChromMap, COMPONENTS,CONT, genomeCappedPlus, compMap);
            leaves= numberLeaves(compTree, Qtd_Tree);
            free(leafToIndexMap);
            leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
            free(geneInCompArray);
            geneInCompArray=generateGeneInCompArray( COMPONENTS, genomeCappedPlus, nbegnes);//validado
            free(geneAtCompBorderArray);
            geneAtCompBorderArray= generateGeneAtCompBorderArray(COMPONENTS, genomeCappedPlus, nbegnes);
     	    free(treeIndexMap);
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
            free(posDepthArray);
            posDepthArray=generatePosDepthArray(genomeCappedPlus, COMPONENTS,nbegnes);
            newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
            dist_escrava=newTransDistance;
            cont_dist++;
        }//end of the first if
        
        if (leaves%2==1)
        {
            
        	if(Qtd_Tree==1)
            {
                
                int iMiddleLeaf = leaves / 2;
                int iComp=-1;
                for (i=0; i<compTree[0].size_tree; i++)
                {
                    if (compTree[0].arvore[i].isleaf)
                    {
                        iComp++;
                        if ( iComp==iMiddleLeaf)
                            break;
                    }
                }
                
                if (iComp==-1)
                {
                    printf("LANCAR ERRO EM QTD_TREE==1 HA UM ERRO \n");
                    break;
                }
                iComp=i;
                
                int start =compTree[0].arvore[iComp].start;
                generateInvolvedExtremities(start, genomeCappedPlus, newChromMap, geneInCompArray, geneAtCompBorderArray, posDepthArray, entrada,siz,involvExtremities);
                
            }//end if
            
            
            else
            {
    			//busca a arvore com mais filhos, aqui tambem descubro a primeira folha da maior arvore
                int maior=0;
        	 	for (i=0; i<Qtd_Tree; i++)
                {
                    if(compTree[i].size_tree>  compTree[maior].size_tree)
                        maior=i;
                    
                }//end for
                
                ///////////////////////////////////////////////
                //----- fim busca maior------------------------
                
                //buscando uma folha da maior arvore, vamus busca a primeira folha
                int pare=0;
                for (i=0; i<Qtd_Tree; i++)
                {
                    for (j=0; j<compTree[i].size_tree; j++)
                    {
                        if (compTree[i].arvore[j].isleaf)
                        {
                            pare=1;
                            break;
                        }
                        
                    }
                    if (pare) {
                        break;
                    }
                    
                }//end for
                int Start= compTree[i].arvore[j].start;
                
                if(Start > TAMANHO_CAPPEPLUS || Start<0)
                {    printf("houve um erro fatal em pegar uma componente para destruir, shutdown");
                    break;
                }//end if
                
                generateInvolvedExtremities(Start, genomeCappedPlus, newChromMap, geneInCompArray, geneAtCompBorderArray, posDepthArray, entrada,siz,involvExtremities);
                
            }//end else
            
            //------------------------------save operations---------------------------------------
            
	        contop++;
            adjG1= assignInvolvedExtr( involvExtremities,adjG1, 1);
            operationList[contop].p1[0]=involvExtremities[0];
            operationList[contop].p1[1]=involvExtremities[3];
            operationList[contop].p2[0]=involvExtremities[1];
            operationList[contop].p2[1]=involvExtremities[2];
            //clonar a lista
            operationList[contop].lista= (int *) calloc (siz, sizeof (int));
            
            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            //----------------------- update all data structures after operation -----------------
            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            
            generateGenome(adjG1,2*qtd_genes+1);
            newentrada=reconstruirentrada(newentrada,siz);
            for (i=0; i<siz; i++)
                operationList[contop].lista[i]=newentrada[i];
            //atualizando entrada pra nao comprometer a ideia aplicada aos outros arquivos
            genNewChromMap( newentrada,siz,newChromMap);// atualizando newChromMap (validado)
            cappingP(newentrada,siz);//atualizando
            cappingM(newentrada, siz);
            free(COMPONENTS);
            free(genomeCappedPlus);
            free(genomeCappedMinus);
            identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
            COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
            free(compTree);
            compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
            generateCompMap(newChromMap, COMPONENTS,CONT, genomeCappedPlus, compMap);
            leaves= numberLeaves(compTree, Qtd_Tree);
            free(leafToIndexMap);
            leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
            free(geneInCompArray);
            geneInCompArray=generateGeneInCompArray( COMPONENTS, genomeCappedPlus, nbegnes);//validado
            free(geneAtCompBorderArray);
            geneAtCompBorderArray= generateGeneAtCompBorderArray(COMPONENTS, genomeCappedPlus, nbegnes);
            free(posDepthArray);
            posDepthArray=generatePosDepthArray(genomeCappedPlus, COMPONENTS,nbegnes);
            free(treeIndexMap);
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
            newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
            dist_escrava=newTransDistance;
            cont_dist++;
     	}//end if leaves impar
        
        needAnotherPreStep = allGenesInComps;//allGenesInComps eh global
        if (leaves==1 && Qtd_Tree==1)
            needAnotherPreStep=1;
        
        
    }//end while
    
    
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    //while the genome is not sorted apply cases of "lemma 4/12", first components on different chromosomes
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    int start;
    int genomeSorted = 0;
    int contapassada=0;//
    while (!genomeSorted)
    {
        
        int compsOnDiffChroms = 0;
        scndCase = 0;
        if (CONT > 0)
            compsOnDiffChroms = testCompsOnDiffChroms(compMap, CONT, COMPONENTS,CONT);
        
        
        if (compsOnDiffChroms)
        { //there exist intrachromosomal components on different chromosomes then
            //perform a bad translocation such that T' = 0, or T' > 1 and L' is even (Lemma 4)
            /*
             * 2 Cases: T has > 1 or = 1 leaf. If T has 1 leaf T2 also has 1 leaf & both can be destroyed
             * In 1st case choose second leaf from the left of biggest tree and pair it with any leaf of t2.
             * In 2nd case choose first leaf of each tree (there is only 1)
             * if theres the possibility that the operation doesnt fit anyway then add index saying which
             * adjacencies of the comps have already been tested when testing next operation
             */
            
            
            int nodeIBigTree=0;
            for (i=0; i<Qtd_Tree; i++)
            {
                if(compTree[i].size_tree > compTree[nodeIBigTree].size_tree)
                    nodeIBigTree=i;
                
            }//end for
            
            //localizando o cromossomo
            int chromNbBiggest = compMap[nodeToCompMap[nodeIBigTree]];
            //pegando a segunda maior arvore q esteja em um cromossomo diferente
            int node2ndBig;
            if(nodeIBigTree==0)
                node2ndBig = 1;
            else
                node2ndBig=0;
            // verifica_crhom(int posgene, int entrada[],int siz);
            for (i=0; i<Qtd_Tree; i++)
            {
                if((compTree[i].size_tree >= compTree[node2ndBig].size_tree) && i!=nodeIBigTree )
                {
                    for (j=0; j<compTree[i].size_tree; j++)
                    {
                        if (compTree[i].arvore[j].isleaf)
                        {
                            
                            if (verifica_crhom(compTree[i].arvore[j].start, newentrada , siz)!=chromNbBiggest) {
                                node2ndBig=i;
                            }
                            
                        }//end if
                        
                    }//end for
                    
                    //calculando quanto filhos tem a segunda maior arvore
                }//end if
                
            }//end for
            
            
            //get second or first leaf belonging to biggest tree
            int i2ndLeaf = 0;
            
            //procurar caso exista uma segunda folha na maior arvore
            i=0;
            for (j=0; j<compTree[nodeIBigTree].size_tree; j++)
            {
                if (compTree[nodeIBigTree].arvore[j].isleaf)
                {
                    i++;
                    i2ndLeaf=j;
                    if (i==2)
                        break;
                }//end if
                
            }//end for
            if (compTree[nodeIBigTree].arvore[i2ndLeaf].isleaf==1)
            {
                start = compTree[nodeIBigTree].arvore[i2ndLeaf].start;
            }
            else
            {
                printf("ALERTA HA UM ERRO NA ESTRUTURA DE DADOS ARMAZEM DE ARVORES, AO TENTAR PEGAR UMA FOLHA EM node2ndBig FORCANDO SAIDA\n");
                break;
            }
            
            involvExtremities[0] = getExtremity1(genomeCappedPlus[start] * 2, 1);
            involvExtremities[1] = getExtremity1(genomeCappedPlus[start + 1] * 2, 0);
            //pegar a primeira folha da segunda grande arvore
            for (j=0; j<compTree[node2ndBig].size_tree; j++)
            {
                if (compTree[node2ndBig].arvore[j].isleaf)
                {
                    break;
                }//end if
                
            }//end for
            
            if (compTree[node2ndBig].arvore[j].isleaf==1) {
                start=compTree[node2ndBig].arvore[j].start;
            }
            else
            {
                printf("ALERTA HA UM ERRO NA ESTRUTURA DE DADOS ARMAZEM DE ARVORES, AO TENTAR PEGAR UMA FOLHA EM node2ndBig FORCANDO SAIDA\n");
                break;
            }
            involvExtremities[2] = getExtremity1(genomeCappedPlus[start] * 2, 1);
            involvExtremities[3] = getExtremity1(genomeCappedPlus[start + 1] * 2, 0);
            //update data structures-------------------------------------------------------------------------------
            
            
            for (i=0; i<2 * qtd_genes + 1; i++) {
                adjNew[i]=adjG1[i];
            }
            adjNew= assignInvolvedExtr( involvExtremities,adjNew, 1);
            
            generateGenome(adjNew,2*qtd_genes+1);
            newentrada=reconstruirentrada(newentrada,siz);
            int chromNb = 1;
            for (i = 0; i < qtd_cromossomo; ++i)
            {
                newChromMap[i]=0;
            }
            int *a= status_A(entrada,siz);
            for (i = 1; i < qtd_cromossomo; ++i)
            {
                for (j = 0; j < a[i]; ++j)
                {
                    int geneL = GENOMA_A[i][j];
                    newChromMap[abs(geneL)] = chromNb;
                }
                ++chromNb;
            }//end for
            
            cappingP(newentrada,siz);//atualizando
            cappingM(newentrada, siz);
            free(COMPONENTS);
            free(genomeCappedPlus);
            free(genomeCappedMinus);
            identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
            COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
            free(compTree);
            compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
            newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );
            
        }//end if
        
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        //--------------in case all components are located on the same chromosome, separate them---------------
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        else if(!compsOnDiffChroms && checkCompLength(COMPONENTS,CONT))
        {
            clona_genoma();//savegenome
            savePlusCapped=SavePlusCapped(genomeCappedPlus,savePlusCapped);//validado
            saveMinCapped=SaveMinCapped(genomeCappedMinus,saveMinCapped);
            int size2=leaves;//marca a qtd de arvores com folhas
            int chromCheck = 1; //true if both genes are on same chrom, false otherwise
            int scndIndex = 0;
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
            i=0;
            j=0;
            while (chromCheck==1 && i < size2 - 1)
            { //retrieve first cut. loop for walking between all comps on the chrom
                int endFstNode = COMPONENTS[nodeToCompMap[treeIndexMap[i]]].endIndex;
                int endSmallerScndNode = COMPONENTS[nodeToCompMap[treeIndexMap[i + 1] - 1]].endIndex;
                int start = 0;
                if (endFstNode < endSmallerScndNode)
                {
                    //last comp before start of next tree is the interesting one, therefore endindex is directly obtained
                    start = endSmallerScndNode;
                }
                else
                {
                    start = endFstNode;
                }
                
                
                int scndComp = nodeToCompMap[getFstLeafOfTree(treeIndexMap[i + 1], leafToIndexMap,leaves)];
                int end = COMPONENTS[scndComp].startIndex;
                involvExtremities[0] = getExtremity1(genomeCappedPlus[start] * 2, 1);
                involvExtremities[1] = getExtremity1(genomeCappedPlus[start + 1] * 2, 0);
                scndIndex = start;
                
                //daqui pra frente precisa ser validado
                if (improper)
                {
                    int isImproper = 1;
                    while (isImproper)
                    {
                        ++scndIndex;
                        //cont_improper=0 e o contador de improper
                        isImproper=checkImproper(getExtremity1(genomeCappedPlus[scndIndex] * 2, 1), involvExtremities[2],adjG1,improperAdjs,cont_improper);
                        
                    }//end while
                    
                    
                    involvExtremities[0] = getExtremity1(genomeCappedPlus[scndIndex] * 2, 1);
                    involvExtremities[1] = getExtremity1(genomeCappedPlus[scndIndex + 1] * 2, 0);
                }
                
                while (chromCheck == ChromCheck(genomeCappedPlus, newChromMap, scndIndex, qtd_genes) && scndIndex < end)
                {
                    ++scndIndex;
                    involvExtremities[0] = getExtremity1(genomeCappedPlus[scndIndex] * 2, 1);
                    involvExtremities[1] = getExtremity1(genomeCappedPlus[scndIndex + 1] * 2, 0);
                }
                ++i;
                
            }//end while start
            
            
            scndCut = genScndCut(genomeCappedPlus,scndCut);
            
            involvExtremities[2] = scndCut[0];
            involvExtremities[3] = scndCut[1];
            improper = 0;
            lastImpr = involvExtremities[0];
            int scnd = 0;
            
            
            
            while (++scnd <= 2)
            { //TODO: Check unneccessary because of scnd cut generator?
                
                adjArray1 = clonar_adjG1( adjArray1,adjG1, 2*qtd_genes+1);//adjG1 tem esse tamanho, a clonagem esta ok
                
                if (scnd == 1)
                {
                    adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 1);
                }
                else
                {
                    adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 0);
                }
                
                
                //generate new genomeA and Adjacency graph
                
                generateGenome(adjArray1,2*qtd_genes+1);
                newentrada=reconstruirentrada(newentrada,siz);
                free(COMPONENTS);
                free(genomeCappedPlus);
                free(genomeCappedMinus);
                identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
                COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
		        if (checkCompLength(COMPONENTS,CONT))
		        {
                    cappingP(newentrada,siz);//atualizando
                    cappingM(newentrada, siz);
                    free(compTree);
                    compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
			        newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );//numberOfCycles global de
                    
                    
                    
                    if (newTransDistance < dist_escrava)
                    {
                        if (scnd == 2)
                        {
                            scndCase = 1;
                        }
                        improper = 0;
                        ++scnd;
                        lastImpr = 2;
                    }
                    
                    else if (scnd == 2)
                    {
                        
                        improperAdjs[cont_improper]=involvExtremities[0];
                        cont_improper++;
                        improperAdjs[cont_improper]=involvExtremities[1];
                        cont_improper++;
                        improperAdjs[cont_improper]=involvExtremities[2];
                        cont_improper++;
                        improperAdjs[cont_improper]=involvExtremities[3];
                        cont_improper++;
                        improper = 1;
                        recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                        recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                        rec_genoma();//recupera savegenome
                        newentrada=reconstruirentrada(newentrada,siz);
                        free(COMPONENTS);
                        free(genomeCappedPlus);
                        free(genomeCappedMinus);
                        identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
                        COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
                        free(compTree);
                        compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
                    }//end else if
                    
                }//end if
                
                else if (scnd == 2)
                {
                    improperAdjs[cont_improper]=involvExtremities[0];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[1];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[2];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[3];
                    cont_improper++;
                    improper = 1;
                    recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                    recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                    rec_genoma();//recupera savegenome
                    newentrada=reconstruirentrada(newentrada,siz);
                    free(COMPONENTS);
                    free(genomeCappedPlus);
                    free(genomeCappedMinus);
                    identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
                    COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
                    free(compTree);
                    compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
                }//end else
                
                
            }//end while
            
            
        }//end else if
        
        
        else
        {
            /*
             * Standard case of performing a proper translocation sorting the genome.
             * proper, if for prefix-prefix translocation there's a cycle (uv...fg..u) and for
             * prefix-suffix trans (with gene inversion) there's a cycle (uv...gf..u) in Adjacency graph.
             */
            
            
            //aqui vou verificar se existe apenas uma translocacao possivel, se for o caso isso será realizado
            
            int ex = adjG1[lastImpr];
            int startEx = lastImpr;
            int chromNbStart = newChromMap[(ex + 1) / 2];
            int chromNb = newChromMap[(startEx + 1) / 2];
            if (!improper)
            {
                int t;
                for(t=0;t <2 * qtd_genes + 1;t++ )
                    visited[t]=0;
            }
            
            visited[startEx] = 1;
            visited[ex] = 1;
            int fstGenome = 0;
            while (chromNbStart == chromNb || (chromNbStart != chromNb && !fstGenome))
            {
                contapassada++;
                
                //passo para fechar lacuna
                if (contapassada==340) {
                    break;
                    
                }
                
                if (fstGenome)
                {
                    
                    
                    ex = adjG1[ex];
                    
                    chromNb = newChromMap[(ex + 1) / 2];
                    fstGenome = 0;
                    
                    
                }
                
		        else
                {
                    
                    
                    
                    ex = adjG2[ex];
                    chromNb = newChromMap[(ex + 1) / 2];
                    fstGenome = 1;
                    
                    
                }
                visited[ex] = 1;
                
                if (startEx == ex )
                {
                    
                    
                    while (visited[startEx])
                    {
                        ++startEx;
                        chromNbStart = newChromMap[(startEx + 1) / 2];
                        chromNb = newChromMap[(startEx + 1) / 2];
                        ex = startEx;
                        
                    }//end while
                    
                    visited[ex] = 1;
                    fstGenome = 0;
                }//end if
                
                
                if (improper)
                {
                    
                    while (checkImproper( ex, startEx, adjG1, improperAdjs, cont_improper))
                    {
                        
                        int oldEx = ex;
                        int fst = 1;
                        while (ex != oldEx || fst)
                        {
                            if (fstGenome)
                            {
                                visited[ex] = 0;
                                ex = adjG1[ex];
                                fstGenome = 0;
                            }
                            else
                            {
                                visited[ex] = 0;
                                ex = adjG2[ex];
                                fstGenome = 1;
                            }
                            fst = 0;
                        }//end while
                        
                        ++startEx;
                        ex = startEx;
                        chromNbStart = newChromMap[(startEx + 1) / 2];
                        chromNb = newChromMap[(startEx + 1) / 2];
                        
                    }//end while externo
                    
                }//end if
                
            }//end while
            
            improper = 0;
            involvExtremities[0] =startEx;
            involvExtremities[1] =adjG1[startEx];
            involvExtremities[2] =ex;
            involvExtremities[3] = adjG1[ex];
            if (contapassada==340)
            {
                int rec=unica_translocacao(newentrada, siz);
                int rec2=-1;
                if (rec!=0)
                {
                    
                    rec2=recuperasegundogene(rec,newentrada, siz);
                    if (rec2==0 || rec2== siz-1 || newentrada[rec2+1]==0 ||newentrada[rec2-1]==0) {
                        printf("\n*************ERROR SERIO EM UNICA TRANSLOCACAO**************\n");
                        break;
                        
                    }
                    
                    //aqui irei fazer um trato caso apareca outro tipos eu acrescento
                    
                    involvExtremities[0]=0;
                    involvExtremities[1]=0;
                    involvExtremities[2]=0;
                    involvExtremities[3]=0;
                    if (newentrada[rec]<newentrada[rec2]) {
                        if (newentrada[rec]<0) {
                            involvExtremities[0] = 2*abs(newentrada[rec])-1;//startEx;
                        }
                        
                        if (newentrada[rec+1]>0) {
                            involvExtremities[1] =2*abs(newentrada[rec+1])-1;// adjG1[startEx];
                        }
                        
                        
                        if (newentrada[rec2-1]>0) {
                            involvExtremities[2] = 2*abs(newentrada[rec2-1]);
                        }
                        
                        if (newentrada[rec2]<0) {
                            involvExtremities[3] = 2*abs(newentrada[rec2]);//adjG1[ex];
                        }
                        
                    }
                    
                    
                    if (involvExtremities[0]==0 ||involvExtremities[1]==0 ||involvExtremities[2]==0 || involvExtremities[3]==0) {
                        printf("\n*************ERROR SERIO EM UNCA TRANSLOCACAO ACRESCENTAR REGRA**************\n");
                        break;
                        
                    }
                    
                    
                }
                
                
                
            }
            
            if (involvExtremities[0]==involvExtremities[2] || involvExtremities[1]==involvExtremities[3]) {
                printf("entrei aqui pro gato ***********\n");
                break;
                
            }
            
            
            lastImpr = startEx;
            
            int scnd = 0;
            clona_genoma();//savegenome
            savePlusCapped=SavePlusCapped(genomeCappedPlus,savePlusCapped);//validado
            saveMinCapped=SaveMinCapped(genomeCappedMinus,saveMinCapped);
            
            while (++scnd <= 2)
            {
                adjArray1 = clonar_adjG1( adjArray1,adjG1, 2*qtd_genes+1);//adjG1 tem esse tamanho, a clonagem esta ok
                
                if (scnd == 1)
                {
                    adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 1);
                    
                    
                }
                else
                {
                    adjArray1 = assignInvolvedExtr(involvExtremities, adjArray1, 0);
                    
                    
                    
                }
                //generate new genomeA and Adjacency graph
	            
                generateGenome(adjArray1,2*qtd_genes+1);
                newentrada=reconstruirentrada(newentrada,siz);
                free(COMPONENTS);
                free(genomeCappedPlus);
                free(genomeCappedMinus);
                identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
                COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
                
                
                if (!checkCompLength(COMPONENTS,CONT))
                {
                    
                    cappingP(newentrada,siz);//atualizando
                    cappingM(newentrada, siz);
                    if (Qtd_Tree!=0)
                        free(compTree);
                    
                    compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
                    newTransDistance= calcTransDist(numberOfCycles, qtd_genes,  qtd_cromossomo,leaves, Qtd_Tree );//numberOfCycles global de
                    if (newTransDistance < dist_escrava)
                    { contapassada=0;
                        
                        if (scnd == 2)
                        {
                            scndCase = 1;
                        }
                        improper = 0;
                        ++scnd;
                        lastImpr = 2;
                        
                    }
                    else if (scnd == 2)
                    {
                        
                        improperAdjs[cont_improper]=involvExtremities[0];
                        cont_improper++;
                        improperAdjs[cont_improper]=involvExtremities[1];
                        cont_improper++;
                        improperAdjs[cont_improper]=involvExtremities[2];
                        cont_improper++;
                        improperAdjs[cont_improper]=involvExtremities[3];
                        cont_improper++;
                        improper = 1;
                        recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                        recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                        rec_genoma();//recupera savegenome
                        newentrada=reconstruirentrada(newentrada,siz);
                        free(COMPONENTS);
                        free(genomeCappedPlus);
                        free(genomeCappedMinus);
                        identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
                        COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
                        free(compTree);
                        compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);
                    }
                }//end if
                else if (scnd == 2)
                {
                    
                    improperAdjs[cont_improper]=involvExtremities[0];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[1];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[2];
                    cont_improper++;
                    improperAdjs[cont_improper]=involvExtremities[3];
                    cont_improper++;
                    improper = 1;
                    recoveryPlusCapped( savePlusCapped, genomeCappedPlus, TAMANHO_CAPPEPLUS);
                    recoveryMinCapped(saveMinCapped, genomeCappedMinus, TAMANHO_CAPPEPLUS);
                    rec_genoma();//recupera savegenome
                    newentrada=reconstruirentrada(newentrada,siz);
                    free(COMPONENTS);
                    free(genomeCappedPlus);
                    free(genomeCappedMinus);
                    identifyComponents2( newentrada,entrada2, siz,1);//carrega funcoes para calculo de indentificacao de componentes
                    COMPONENTS=compIdentificationPhase12(nbegnes,newentrada, entrada2, siz);// validado, esta ok
                    free(compTree);
                    compTree= generateCompTree(newentrada, entrada2, siz,genomeCappedMinus,genomeCappedPlus,COMPONENTS,0);//validado
                    
                }//end else if
                
            }//end while
            
        }//end else
        
        
        //-----------------------------save operations------------------------------------------------------------
        if (!improper && newTransDistance < dist_escrava)
        {
            
            cont_improper=0;
            contop++;
            if (scndCase)
            {
                
                adjG1= assignInvolvedExtr( involvExtremities,adjG1, 0);
                operationList[contop].p1[0]=involvExtremities[0];
                operationList[contop].p1[1]=involvExtremities[2];
                operationList[contop].p2[0]=involvExtremities[1];
                operationList[contop].p2[1]=involvExtremities[3];
                
            }
            else
            {
                adjG1= assignInvolvedExtr( involvExtremities,adjG1, 1);
                operationList[contop].p1[0]=involvExtremities[0];
                operationList[contop].p1[1]=involvExtremities[3];
                operationList[contop].p2[0]=involvExtremities[1];
                operationList[contop].p2[1]=involvExtremities[2];
                
            }
            
            genNewChromMap( newentrada,siz, newChromMap);// atualizando newChromMap (validado)
            generateCompMap(newChromMap, COMPONENTS,CONT,genomeCappedPlus, compMap);
            leaves= numberLeaves(compTree, Qtd_Tree);
            free(leafToIndexMap);
            leafToIndexMap=getLeafToIndexMap(compTree, Qtd_Tree,  leaves);
            free(treeIndexMap);
            treeIndexMap= TreeIndexMap(compTree,Qtd_Tree,leaves);
            operationList[contop].lista= (int *) calloc (siz, sizeof (int));
            for (i=0; i<siz; i++)
            {
                operationList[contop].lista[i]=newentrada[i];
            }
            dist_escrava=newTransDistance;
            
            if (dist_escrava == 0) {
                genomeSorted = 1;
            }
            
        }//end if save operations
        
        
        cont_dist++;
        
        //if(xi==1)
        //   break;
        
    }//end while inicial
    
    printf("\n**************mostrar as translocacoes **********\n");
    
    for(i=0;i<=contop;i++)
    {
        printf("%d:",i);
        for(j=0;j<siz;j++)
        {     if(j==0)
            printf("(%d,",operationList[i].lista[j]);
        else if(j+1==siz)
            printf("%d)",operationList[i].lista[j]);
        else if(operationList[i].lista[j]==0)
            printf(") (");
        else if(operationList[i].lista[j+1]==0)
            printf("%d",operationList[i].lista[j]);
        else
            printf("%d,",operationList[i].lista[j]);
        }
        
        printf("\n");
    }
    
    //grava(operationList, contop, siz,entrega);
    return distancia;
}//end d_tranlocation

void CompTreeGeneration(int entrada[],int entrada2[], int siz)
{
   //generateCompTree(entrada, entrada2, siz);
    d_tranlocation(entrada,entrada2, siz);
// printf("Distance nova e:%d\n",distance(entrada, entrada2, siz));
}// end compTreeGeneration

/*
int main()
{
    
 
 
 //mouse genome this distance x human is 52
 
 int entrada[164]={1,14,15,16,17,-9,-8,-7,10,0,11,61,62,-58,-57,-56,-13,-12,-73,-72,111,112,-114,-113,18,0,19,2,3,4,5,6,24,25,26,0,
 27,41,42,53,54,55,32,0,44,45,46,47,0,33,78,79,80,81,82,83,43,0,52,-71,-70,65,68,69,59,0,48,49,50,51,0,
 60,-21,-20,22,23,92,93,74,75,66,0,67,88,89,117,76,0,77,30,96,-100,-99,-98,-97,101,102,103,104,90,0,
 91,31,34,35,94,0,95,28,29,118,119,84,85,-87,-86,105,0,106,36,37,38,39,40,109,0,110,107,108,115,0,
 116,63,64,120,0,121,122,123,-135,-134,-133,-132,-131,124,125,138,139,-137,-136,-130,-129,-128,126,127,140,0,
 141,142,143,144,145,146,147
 };
 
 //cat genome distance x human is 45
 int entrada[164]={27,-31,-30,28,29,32,0,11,21,18,0,19,113,114,-112,-111,26,0,48,49,50,51,0,33,41,42,-40,-39,-38,-37,-36,34,35,43,0,91,92,93,94,0,
 1,61,62,-79,-78,-81,-80,82,83,84,85,86,87,88,89,118,119,10,0,106,2,3,4,-13,-12,14,15,16,17,109,0,60,-20,22,23,24,25,66,0,
 67,-75,-74,70,71,-73,-72,68,69,76,0,77,63,64,65,90,0,110,-108,-107,117,115,0,52,-58,-57,-56,-55,-54,53,59,0,95,-104,-103,101,102,97,98,99,100,96,105,0,
 44,45,46,47,0,116,5,6,-9,7,8,120,0,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,-139,-138,140,0,
 141,142,143,144,145,146,147};

 //Human genome
 int entrada2[164]={ 1,2,3,4,5,6,7,8,9,10,0,11,12,13,14,15,16,17,18,0,19,20,21,22,23,24,25,26,0,27,28,29,30,31,32,0,33,34,35,36,37,38,39,40,41,42,43,0,44,45,46,47,0,
 48,49,50,51,0,52,53,54,55,56,57,58,59,0,60,61,62,63,64,65,66,0,67,68,69,70,71,72,73,74,75,76,0,77,78,79,80,81,82,83,84,85,86,87,88,89,90,0,
 91,92,93,94,0,95,96,97,98,99,100,101,102,103,104,105,0,106,107,108,109,0,110,111,112,113,114,115,0,116,117,118,119,120,0,121,122,123,124,125,126,
 127,128,129,130,131,132,133,134,135,136,137,138,139,140,0,141,142,143,144,145,146,147};



//mouse genome distance x cat is 51
int entrada[164]={1,59,60,61,62,117,-119,-118,6,0,7,36,37,92,93,94,57,58,76,77,-14,-13,-12,-11,9,0,10,54,55,56,115,116,68,69,15,0,20,21,22,-97,-96,-95,30,0,
    110,111,112,113,0,31,-39,-38,-41,-40,42,43,34,0,35,-75,-74,84,78,79,52,0, 16,17,18,19,0,53,8,65,66,67,32,33,-73,-72,63,0,64,48,49,89,70,0,71,3,
    -108,-107,-106,-105,-104,102,103,-101,-100,80,0,81,2,28,29,85,0,86,4,5,50,51,44,45,-47,-46,90,0,91,-27,-26,-25,-24,-23,98,0,99,-88,-87,109,0,
    114,82,83,120,0,121,122,123,-135,-134,-133,-132,-131,124,125,-139,-138,-137,-136,-130,-129,-128,126,127,140,0,141,142,143,144,145,146,147};



//cat genome is identity
int entrada2[164]={1,2,3,4,5,6,0,7,8,9,0,10,11,12,13,14,15,0,16,17,18,19,0,20,21,22,23,24,25,26,27,28,29,30,0,31,32,33,34,0,
    35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,0,53,54,55,56,57,58,59,60,61,62,63,0,64,65,66,67,68,69,70,0,
    71,72,73,74,75,76,77,78,79,80,0,81,82,83,84,85,0,86,87,88,89,90,0,91,92,93,94,95,96,97,98,0,99,100,101,102,103,104,105,106,107,108,109,0,
    110,111,112,113,0,114,115,116,117,118,119,120,0,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,0,
    141,142,143,144,145,146,147};


 int entrada[164]={1,14,15,16,17,-9,-8,-7,10,0,11,61,62,-58,-57,-56,-13,-12,-73,-72,111,112,-114,-113,18,0,19,2,3,4,5,6,24,25,26,0,
 27,41,42,53,54,55,32,0,44,45,46,47,0,33,78,79,80,81,82,83,43,0,52,-71,-70,65,68,69,59,0,48,49,50,51,0,
 60,-21,-20,22,23,92,93,74,75,66,0,67,88,89,117,76,0,77,30,96,-100,-99,-98,-97,101,102,103,104,90,0,
 91,31,34,35,94,0,95,28,29,118,119,84,85,-87,-86,105,0,106,36,37,38,39,40,109,0,110,107,108,115,0,
 116,63,64,120,0,121,122,123,-135,-134,-133,-132,-131,124,125,138,139,-137,-136,-130,-129,-128,126,127,140,0,
 141,142,143,144,145,146,147
 };
 
 
 //Human genome
 //int entrada2[164]={ 1,2,3,4,5,6,7,8,9,10,0,11,12,13,14,15,16,17,18,0,19,20,21,22,23,24,25,26,0,27,28,29,30,31,32,0,33,34,35,36,37,38,39,40,41,42,43,0,44,45,46,47,0,
 48,49,50,51,0,52,53,54,55,56,57,58,59,0,60,61,62,63,64,65,66,0,67,68,69,70,71,72,73,74,75,76,0,77,78,79,80,81,82,83,84,85,86,87,88,89,90,0,
 91,92,93,94,0,95,96,97,98,99,100,101,102,103,104,105,0,106,107,108,109,0,110,111,112,113,114,115,0,116,117,118,119,120,0,121,122,123,124,125,126,
 127,128,129,130,131,132,133,134,135,136,137,138,139,140,0,141,142,143,144,145,146,147};
 

 
 //   int entrada[25]={1,3,0,4,5,6,0,7,8,9,0,10,11,12,0,13,2,14,15,0,16,17,-18,19,20};
   // int entrada2[25]={1,2,3,0,4,5,6,0,7,8,9,0,10,11,12,0,13,14,15,0,16,17,18,19,20};
 
    //  int entrada[21]={1,3,-4,-19,17,20,0,11,-5,-6,-7,8,13,12,16,-15,-14,2,18,-9,10};
    // int entrada2[21]={1,2,3,4,5,6,7,8,9,10,0,11,12,13,14,15,16,17,18,19,20};
    
    
    //int entrada[13]={1,2,-4,-3,5,-6,8,7,9,10,0,11,12};
    //int entrada2[13]={1,2,3,4,5,6,7,8,9,10,0,11,12};
    // int entrada[18]={1,-7,-2,-5,-4,-3,-6,-9,-8,10,0,11,-13,-15,-14,-16,-12,17};
    // int entrada2[18]={1,2,3,4,5,6,7,8,9,10,0,11,12,13,14,15,16,17};
    int entrada[155]={1,118,-29,2,68,-79,-78,75,0,26,-99,117,123,146,-86,-85,115,37,-81,-39,-38,96,-94,-93,-74,-55,125,0,51,69,-70,-28,111,-92,-113,-90,40,-41,42,-127,134,-149,-119,52,-53,71,-10,-9,-8,-7,-6,-5,4,-18,-17,-16,-15,-14,13,-12,57,58,59,60,61,62,63,67,20,21,-66,-65,64,114,-45,-44,46,47,48,139,130,140,50,0,76,131,-122,138,137,104,-103,-102,-147,105,-135,-54,110,-106,-80,116,82,23,24,-84,-83,-22,25,0,101,95,32,-36,-35,-34,-33,-97,30,31,109,-91,-129,98,-120,100,0,126,-73,43,11,-72,143,128,49,77,56,19,-108,145,124,136,-142,87,88,89,27,3,112,-121,-144,141,-133,148,-107,-132,150};
    
    int entrada2[155]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,0,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,0,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,0,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,0,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150};
   // int entrada[101]={1,99,98,46,29,76,75,2,30,31,90,72,94,37,70,35,74,88,56,36,34,25,44,45,47,40,22,18,79,80,81,82,42,10,27,32,21,87,77,96,95,7,16,17,61,54,63,53,83,11,12,71,15,14,13,69,68,55,93,100,0,51,86,33,57,26,8,39,78,20,19,23,48,97,28,65,64,67,66,60,52,24,62,91,92,43,41,89,73,58,59,9,3,38,84,85,4,5,6,49,50};
    //int entrada2[101]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,0,51,52,53,54 ,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100 };
    // int entrada[14]={1,2,0,3,4,0,5,10,0,7,6,0,9,8};
    // int entrada2[14]={1,2,0,3,4,0,5,6,0,7,8,0,9,10};
    //int entrada[11]={1,-2,3,6,4,-5,7,0,8,-9,10};
    //int entrada2[11]={1,2,3,4,5,6,7,0,8,9,10};
    //int entrada[11]={1,-9,10,0,-7,5,-4,-6,-3,2,-8};
    //int entrada2[11]={1,2,3,4,5,6,7,0,8,9,10};
    // int entrada[7]={1,5,3,0,4,2,6};
    // int entrada2[7]={1,2,3,0,4,5,6};
    // usa-se o 0 para separar os cromossomos no genoma
    //int entrada[11]={4,3,0,1,2,-7,5,0,6,-8,9};
    //int entrada2[11]={1,2,3,0,4,5,0,6,7,8,9};
    //int entrada[7]= {1, 5, 3,0,4, 2, 6};
    //int entrada2[7] ={1, 2, 3,0,4, 5, 6};
    
    //esta com problema precisa ser validado
    //  int entrada[17]={1,-2,3,8,4,-5,6,0,7,9,10,11,12,13,14,15,16};
    //  int entrada2[17]={1,2,3,4,5,6,0,7,8,9,10,11,12,13,14,15,16};
    
    
    //int entrada[13]={1,2,-4,-3,5,12,0,11,6,-8,-7,9,10};
    // int entrada2[13]={1, 2, 3,4 ,5, 6,7 ,8 ,9,10, 0, 11, 12};
    // int entrada[17]={1,2,3,8,4,5,6,0,7,9,10,11,12,13,14,15,16};
    // int entrada2[17]={1,2,3,4,5,6,0,7,8,9,10,11,12,13,14,15,16};
    
    
    //esta errado precisa ser debugado
    //  int entrada[20]={1, -2,3,4,6,5,7,-15,-13,-14, -12, -10, -11, -9, -8, 16,0,17,18,19};
    // int entrada2[20]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,0,17,18,19};
    
    
    //int entrada[52]={1,11,18,34,44,37,23,38,39,35,36,15,21,20,43,31,32,0,17,3,26,14,29,5,6,47,25,24,30,2,27,19,22,13,48,49,4,46,10,7, 28,41,16,0,33,40,42,45,9,8,12,50};
    //int entrada2[52]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,0,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,0,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50};
    //int entrada[22]={1,8,2,9,10,18,17,16,15,14,19,20,0,7,11,12,0,13,3,4,5,6};
    //int entrada2[22]={1,2,3,4,5,6,0,7,8,9,10,11,12,0,13,14,15,16,17,18,19,20};
    
	
    //int entrada[21]={1,6,2,17,13,8,3,-14,-7,-16,-15,-12,20,0,11,-5,-4,18,19,-9,10};
    // int entrada2[21]={1,2,3,4,5,6,7,8,9,10,0,11,12,13,14,15,16,17,18,19,20};
	
    //printf("Saida: %d \n", cromossomo(entrada, entrada2, (sizeof(entrada)/sizeof(int)) ,(sizeof(entrada2)/sizeof(int))));
    
    if (is_cotail( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)))) {
        
        load_genoma( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)));
        
        CompTreeGeneration( entrada, entrada2,(sizeof(entrada)/sizeof(int)));
        
    }
    else
    {
        printf("**************SUA ENTRADA NAO EH COTAIL**************\n");
        
        unica_translocacao( entrada, (sizeof(entrada)/sizeof(int)));
        
    }
    
    
    
    return 0;
}

*/
