//
//  Memetic_alg.h
//  
//
//  Created by Lucas Angelo on 02/06/15.
//
//

#ifndef _Memetic_alg_h
#define _Memetic_alg_h
#include "structure.h"
void read_permutation_of_archivo(char* name, permutation *perm);


// Procedure that generates the initial population

void population_init(population *pob, permutation *perm);

//compute the distance to each genome of the population
void fitness_population(population *pob, int flag);

void countingSort(population *pob, int k);

void selection(population *pob,  int n_generetion, int * best_solution);


void crossover(population *pob, permutation *perm);


void mutation(population *pob, permutation *perm);

void replacement(population *pob);

/* operator local search based in mutation*/
/* The operator is applied over one individual "i"
 * Return 1(true) when we have better results of the indidual i"
 * otherwise return 0(false) */

int auxlocal_search(population *pob, int i);

/* Procedure that applies Local Search over the population
 * if nro_generacion is equal to 1, it means is the initial pop0
 */
void local_search(population *pob, int nro_generation);

/* method that resert the population, conservando una parte
 * e generando aleatoriamente el resto para luego
 * ser aplicado busqueda local
 *  */
void restarting_population(population *pob, permutation *perm);



//this function return 1 for reset population and 0 otherwise
int reset_population(population *pob, int i);


void MemeticGa(float probreset, float localsearch, float probretaion);


#endif
